> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Runner Policy

> Creates a new policy for a runner.

`Unary` · [`Runners`](/docs/api-reference/generated/runner/overview)

Creates a new policy for a runner.

Use this method to:

* Set up access controls
* Define group permissions
* Configure role-based access

### Examples

* Create admin policy:

  Grants admin access to a group.

  ```yaml theme={null}
  runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  groupId: "f53d2330-3795-4c5d-a1f3-453121af9c60"
  role: RUNNER_ROLE_ADMIN
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.RunnerService/CreateRunnerPolicy
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.RunnerService/CreateRunnerPolicy" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "runnerId": "<runner-id>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.runner_pb2 as runner_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = runner_pb2.CreateRunnerPolicyRequest(
      runner_id="<runner-id>",
  )
  response = ona.services.runner.create_runner_policy(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { CreateRunnerPolicyRequestSchema } from "@gitpod/sdk/gitpod/v1/runner_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(CreateRunnerPolicyRequestSchema, {
      runnerId: "<runner-id>",
    });
    const response = await ona.services.runner.createRunnerPolicy(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.CreateRunnerPolicyRequest{
  		RunnerId: "<runner-id>",
  	})
  	response, err := ona.Services.Runner.CreateRunnerPolicy(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "runnerId": "<runner-id>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.CreateRunnerPolicyRequest`

CreateRunnerPolicyRequest creates a Runner Policy.

| Field      | Type                                      | Required | Description                                                                   |
| ---------- | ----------------------------------------- | -------- | ----------------------------------------------------------------------------- |
| `runnerId` | string                                    | No       | runner\_id specifies the project identifier Constraints: `string.uuid=true`.  |
| `groupId`  | string                                    | No       | group\_id specifies the group\_id identifier Constraints: `string.uuid=true`. |
| `role`     | [RunnerRole](#enum-gitpod-v1-runner-role) | No       |                                                                               |

## Response

`gitpod.v1.CreateRunnerPolicyResponse`

| Field    | Type                                          | Required | Description                   |
| -------- | --------------------------------------------- | -------- | ----------------------------- |
| `policy` | [RunnerPolicy](#type-gitpod-v1-runner-policy) | Yes      | Constraints: `required=true`. |

## Related types

<a id="type-gitpod-v1-runner-policy" />

<Accordion title="RunnerPolicy">
  `gitpod.v1.RunnerPolicy`

  | Field     | Type                                      | Required | Description                            |
  | --------- | ----------------------------------------- | -------- | -------------------------------------- |
  | `groupId` | string                                    | No       | Constraints: `string.uuid=true`.       |
  | `role`    | [RunnerRole](#enum-gitpod-v1-runner-role) | No       | role is the role assigned to the group |
</Accordion>

<a id="enum-gitpod-v1-runner-role" />

<Accordion title="RunnerRole">
  | Value                     | Number | Description |
  | ------------------------- | -----: | ----------- |
  | `RUNNER_ROLE_UNSPECIFIED` |      0 |             |
  | `RUNNER_ROLE_ADMIN`       |      1 |             |
  | `RUNNER_ROLE_USER`        |      2 |             |
</Accordion>
